/*************** Includes *****************************************************************************************/
#include "system.h"
#include "interrupt_manager.h"

void interrupt INTERRUPT_InterruptManager (void)    // main interrupt handler
{
    if(INTCONbits.TMR0IE == 1 && INTCONbits.TMR0IF == 1)
    {
        TMR0_ISR();
    }
    if(INTCONbits.PEIE == 1 && PIE1bits.TMR1IE == 1 && PIR1bits.TMR1IF == 1)
    {
        TMR1_ISR();
    }
    if(INTCONbits.IOCIE == 1 && INTCONbits.IOCIF == 1)
    {
        INTCONbits.IOCIF = 0;               // clear global interrupt-on-change flag
        PIN_MANAGER_IOC();                  // process IOC interrupt
    }
    if(INTCONbits.INTE == 1 && INTCONbits.INTF == 1)
    {
        APP_IrrigationWatch_INTPin();     // process Flow Sensor interrupts
    }
#ifndef LCD_IOPORT
    if(INTCONbits.PEIE == 1 && PIE2bits.BCL1IE == 1 && PIR2bits.BCL1IF == 1)
    {
        I2C1_BusCollisionISR();             // process I2C Bus Collision interrupt
    }
    if(INTCONbits.PEIE == 1 && PIE1bits.SSP1IE == 1 && PIR1bits.SSP1IF == 1)
    {
        I2C1_ISR();                         // process I2C interrupt
    }
#endif
}
/*************** End of File **************************************************************************************/