/**
  @Generated Pin Manager Header File
  @Company:   Microchip Technology Inc.
  @File Name: pin_manager.h
  @Summary:   This is the Pin Manager file generated using MPLAB(c) Code Configurator
  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.16
        Device            :  PIC16F1829
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.20
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

/**
 * @Param    none
 * @Returns  none
 * @Description    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Description    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

/**
 * @Description    Interrupt on Change Handler for the IOCAF0 pin functionality
 */
void IOCAF0_ISR(void);

/**
  @Description  Allows selecting an interrupt handler for IOCAF0 at application runtime
  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(MyInterruptHandler);
*/
void IOCAF0_SetInterruptHandler(void* InterruptHandler);

/**
  @Summary    Dynamic Interrupt Handler for IOCAF0 pin
*/
void (*IOCAF0_InterruptHandler)(void);

/**
 * @Description    Interrupt on Change Handler for the IOCAF1 pin functionality
 * @Example
    IOCAF1_ISR();
 */
void IOCAF1_ISR(void);

/**
  @Summary    Interrupt Handler Setter for IOCAF1 pin interrupt-on-change functionality
*/
void IOCAF1_SetInterruptHandler(void* InterruptHandler);

/**
  @Summary    Dynamic Interrupt Handler for IOCAF1 pin
*/
void (*IOCAF1_InterruptHandler)(void);

#endif // PIN_MANAGER_H
/*************** End of File **************************************************************************************/